%global projectname     freemedforms

Name:           freemedforms
Version:        0.9.4
Release:        4%{?dist}
Summary:        The freemedforms application suite meta package

License:        GPLv3+ and LGPLv2
URL:            http://www.%{name}.com
Source0:        http://downloads.sourceforge.net/%{projectname}/%{projectname}-project-src_%{version}.tgz

BuildRequires:  qt-devel libXext-devel
BuildRequires:  desktop-file-utils
BuildRequires:  quazip-devel
BuildRequires:  opencv-devel

# pull in emr
Requires:       %{projectname}-emr%{?_isa} >= %{version}-%{release}
# pull in freediams
Requires:       freediams%{?_isa} >= %{version}-%{release}

# filter provides and requires. The so files are private plugins
%{?filter_setup:
%filter_provides_in %{_libdir}/%{name}/
%filter_provides_in %{_libdir}/%{projectname}-common/
%filter_requires_in %{_libdir}/%{name}/
%filter_requires_in %{_libdir}/%{projectname}-common/
%filter_provides_in %{_libdir}/freediams/
%filter_requires_in %{_libdir}/freediams/

%filter_from_requires /libUtils/d ; /libExtensionSystem/d ; /libTranslationUtils/d ; /libAggregation/d

%filter_setup
}
%description
FreeMedForms aims to be a open Electronic Medical Record Manager.
FreeMedForms is also a lot of derivatives sub-project, which are
just standalone compilation of FreeMedForms plugins.

This project is a free and open source project. A community grows up
around it. FreeMedForms and derivatives is released under the terms
of the GPLv3 License. Some parts of the code are LGPL v2.1.

FreeMedForms and Derivatives are coded in C++/Qt4.8+.
FreeMedForms and Derivatives are available for :
- MacOs X
- Linux : Ubuntu, Debian, OpenSuse, standalone binary
- FreeBSD : need compilation of git repo (please contact author)
- Windows

This is a meta package that pulls in the EMR and FreeDiams


%package emr
Summary: The FreeMedForms EMR
Requires: %{projectname}-emr-data >= %{version}-%{release}
Requires: %{projectname}-common-resources >= %{version}-%{release}
Requires: %{projectname}-common-libs%{?_isa} >= %{version}-%{release}
Requires: qt-mysql

# Obsolete previous packages since we've split into new subpackage scheme
Obsoletes:      %{name} < 0.5.9-0.7.alpha1
Obsoletes:      %{name}-devel < 0.5.9-0.7.alpha1

%description emr
The FreeMedForms EMR

Please install the freemedforms-emr-docs-en,fr
or the freemedforms-common-translations packages if required

%package emr-data
Summary:    Architecture independant data used by the freemedforms EMR
BuildArch:  noarch

%description emr-data
This package contains the data packs, images and other architecture independant
data used by the freemedforms EMR

%package emr-docs-en
Summary:    English documentation for the freemedforms EMR
BuildArch:  noarch

%description emr-docs-en
This package contains HTML documentation in English for the freemedforms EMR

%package emr-docs-fr
Summary:    French documentation for the freemedforms EMR
BuildArch:  noarch

%description emr-docs-fr
This package contains HTML documentation in French for the freemedforms EMR

%package common-translations
Summary:    Translation files for the freemedforms EMR
BuildArch:  noarch

%description common-translations
This package contains translation files for the freemedforms suite.
Languages contained are: English, Frence and Deutsch

%package common-libs
Summary: Common files utilized by the freemedforms suite
Requires: qt-sqlite quazip

%description common-libs
These are files that are shared between the applications of the freemedforms
suite, such as freemedforms, freediams, freeaccount, freeicd, freepad,
freetoolbox.

All applications of the suite should require this package when they are
packaged for Fedora instead of re-generating these files. See the freediams
package for hints on how to do this.

%package common-resources
Summary: Common resources used by the freemedforms suite
BuildArch: noarch
Requires: %{projectname}-common-translations >= %{version}-%{release}

%description common-resources
This package contains textfiles that are shared between the applications of the
freemedforms suite such as freemedforms, freediams, freeaccount, freeicd,
freepad, freetoolbox

All applications of the suite should require this package when they are
packaged for Fedora instead of re-generating these files. See the freediams
package for hints on how to do this.

%package -n freediams
Summary:        The pharmaceutical prescription assistant

Requires:       %{projectname}-common-libs%{?_isa} >= %{version}-%{release}
Requires:       %{projectname}-common-resources >= %{version}-%{release}

%description -n freediams
FreeDiams prescriber is the result of FreeMedForms prescriber plugins built
into a standalone application. FreeDiams is a multi-platform (MacOS, Linux,
FreeBSD, Windows), free and open source released under the GPLv3 license.

It is mainly developed by medical doctors and is intended for use by these same
professionals. It can be used alone to prescribe and / or test drug
interactions within a prescription. It can be linked to any application thanks
to its command line parameters.

FreeDiams can manage multiple drugs databases. Some drugs databases are already
available:

    French (sources: AFSSAPS)
    Canadian (sources: HCDPD)
    USA (sources: FDA)
    South African (sources: AEPI)

The interactions database (source: AFSSAPS) give access to many informations:

    interactions by themselves
    risk level
    nature of the risk
    management of the interaction

This is part of the freemedforms suite of applications

%package -n freediams-docs-en
Summary:    English documentation for freediams
BuildArch:  noarch

%description -n freediams-docs-en
This package contains HTML documentation in English for freediams

%package -n freediams-docs-fr
Summary:    French documentation for freediams
BuildArch:  noarch

%description -n freediams-docs-fr
This package contains HTML documentation in French for freediams

%prep
%setup -q -n %{name}-project-%{version}

sed -i 's/\r//' README.txt COPYING.txt
# correct include : could've used a patch too I guess
sed -i 's|#include <quazip/quazip/quazipfile.h>|#include <quazip/quazipfile.h>|' plugins/saverestoreplugin/saverestorepage.cpp

%build
export PATH=$PATH:/usr/%{_lib}/qt4/bin/

# Create all translations
lrelease global_resources/translations/*.ts 

# Build FreeMedForms EMR
pushd freemedforms
            # Plugin broken. Disabled at the moment. Upstream is aware.
            #"CONFIG+=with-webcam" \
    qmake freemedforms.pro -r \
            "CONFIG+=release" "CONFIG-=debug" \
            "CONFIG+=LINUX_INTEGRATED" "CONFIG+=dontbuildquazip" \
            "CONFIG+=with-plugin" "CONFIG+=with-account" \
            "CONFIG+=with-agenda" "CONFIG+=with-alerts" \
            "CONFIG+=with-feedback" "CONFIG+=with-pmh" \
            "LIBRARY_BASENAME=%{_lib}" \
            "INSTALL_ROOT_PATH=$RPM_BUILD_ROOT%{_prefix}"
    cp ../buildspecs/compiling.pri ../build/compiling_freemedforms.pri
    make %{?_smp_mflags}
popd

# Build Freediams
pushd freediams
            # Plugin broken. Disabled at the moment. Upstream is aware.
            #"CONFIG+=with-webcam" \
    qmake freediams.pro -r \
            "CONFIG+=release" "CONFIG-=debug" \
            "CONFIG+=dontbuildlibs" "CONFIG+=dontinstallresources" "CONFIG+=dontinstalllibs" \
            "CONFIG+=LINUX_INTEGRATED" "CONFIG+=dontbuildquazip" \
            "CONFIG+=with-plugin" "CONFIG+=with-account" \
            "CONFIG+=with-agenda" "CONFIG+=with-alerts" \
            "CONFIG+=with-feedback" "CONFIG+=with-pmh" \
            "LIBRARY_BASENAME=%{_lib}" \
            "INSTALL_ROOT_PATH=$RPM_BUILD_ROOT%{_prefix}"
    cp ../buildspecs/compiling.pri ../build/compiling_freediams.pri
    make %{?_smp_mflags}
popd

%install
pushd freemedforms
    cp ../build/compiling_freemedforms.pri ../buildspecs/compiling.pri
    make install DESTDIR=$RPM_BUILD_ROOT
popd

pushd freediams
    cp ../build/compiling_freediams.pri ../buildspecs/compiling.pri
    make install DESTDIR=$RPM_BUILD_ROOT
popd


# Install man pages 'by-hand'
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1/
install -p -m 0644 global_resources/package_helpers/freemedforms.1 -t $RPM_BUILD_ROOT/%{_mandir}/man1/
install -p -m 0644 global_resources/package_helpers/freediams.1 -t $RPM_BUILD_ROOT/%{_mandir}/man1/

# Change the mod of bins/libs to rwxr-xr-x
chmod -v 0755 $RPM_BUILD_ROOT/%{_libdir}/freemedforms-common/*.so*
chmod -v 0755 $RPM_BUILD_ROOT/%{_libdir}/freemedforms/*.so*
chmod -v 0755 $RPM_BUILD_ROOT/%{_bindir}/freemedforms
chmod -v 0755 $RPM_BUILD_ROOT/%{_libdir}/freediams/*.so*
chmod -v 0755 $RPM_BUILD_ROOT/%{_bindir}/freediams

# Fix up and validate desktop file
sed -r -i "s/Categories=Office;MedicalSoftware/Categories=Office;/" ${RPM_BUILD_ROOT}%{_datadir}/applications/%{name}.desktop
sed -r -i "/Version/d" ${RPM_BUILD_ROOT}%{_datadir}/applications/%{name}.desktop
sed -r -i "s/Categories=Office;MedicalSoftware/Categories=Office;/" ${RPM_BUILD_ROOT}%{_datadir}/applications/freediams.desktop
sed -r -i "/Version/d" ${RPM_BUILD_ROOT}%{_datadir}/applications/freediams.desktop
desktop-file-validate  ${RPM_BUILD_ROOT}%{_datadir}/applications/%{name}.desktop
desktop-file-validate  ${RPM_BUILD_ROOT}%{_datadir}/applications/freediams.desktop

# Register as an application to be visible in the software center
#
# NOTE: It would be *awesome* if this file was maintained by the upstream
# project, translated and installed into the right place during `make install`.
#
# See http://www.freedesktop.org/software/appstream/docs/ for more details.
#
mkdir -p $RPM_BUILD_ROOT%{_datadir}/appdata
cat > $RPM_BUILD_ROOT%{_datadir}/appdata/freediams.appdata.xml <<EOF
<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright 2014 Richard Hughes <richard@hughsie.com> -->
<application>
  <id type="desktop">freediams.desktop</id>
  <metadata_license>CC0-1.0</metadata_license>
  <name>Freediams</name>
  <summary>The pharmaceutical prescription assistant</summary>
  <description>
    <p>
      FreeDiams prescriber is the result of FreeMedForms prescriber plugins built
      into a standalone application.
      FreeDiams is a multi-platform (MacOS, Linux, FreeBSD, Windows), free and
      open source released under the GPLv3 license.
      This is part of the freemedforms suite of applications.
    </p>
    <p>
      It is mainly developed by medical doctors and is intended for use by these same
      professionals.
      It can be used alone to prescribe and / or test drug interactions within a
      prescription.
      It can be linked to any application thanks to its command line parameters.
    </p>
    <p>
      FreeDiams can manage multiple drugs databases. Some drugs databases are already
      available:
    </p>
    <ul>
      <li>French (sources: AFSSAPS)</li>
      <li>Canadian (sources: HCDPD)</li>
      <li>USA (sources: FDA)</li>
      <li>South African (sources: AEPI)</li>
    </ul>
    <p>
      The interactions database (source: AFSSAPS) give access to many informations:
    </p>
    <ul>
      <li>Interactions by themselves</li>
      <li>Risk level</li>
      <li>Nature of the risk</li>
      <li>Management of the interaction</li>
    </ul>
  </description>
  <screenshots>
    <screenshot type="default">http://freemedforms.com/_media/shots/freemedforms/060/presentation/multidrugs-en.png</screenshot>
  </screenshots>
  <url type="homepage">http://freemedforms.com/en/start</url>
  <updatecontact>eric.maeker@gmail.com</updatecontact>
</application>
EOF
cat > $RPM_BUILD_ROOT%{_datadir}/appdata/%{name}.appdata.xml <<EOF
<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright 2014 Richard Hughes <richard@hughsie.com> -->
<application>
  <id type="desktop">freemedforms.desktop</id>
  <metadata_license>CC0-1.0</metadata_license>
  <name>FreeMedForms EMR</name>
  <summary>The FreeMedForms Electronic Medical Record Manager</summary>
  <description>
    <p>
      FreeMedForms aims to be a open Electronic Medical Record Manager.
      FreeMedForms is also a lot of derivatives sub-project, which are
      just standalone compilation of FreeMedForms plugins.
    </p>
    <p>
      This project is a free and open source project. A community grows up
      around it. FreeMedForms and derivatives is released under the terms
      of the GPLv3 License. Some parts of the code are LGPL v2.1.
    </p>
  </description>
  <screenshots>
    <screenshot type="default">http://freemedforms.com/_media/shots/freemedforms/080/presentation/generalui-fr.png</screenshot>
    <screenshot>http://freemedforms.com/_media/shots/freemedforms/080/presentation/patientfiles-fr.png</screenshot>
    <screenshot>http://freemedforms.com/_media/shots/freemedforms/060/presentation/calendar-en.png</screenshot>
  </screenshots>
  <url type="homepage">http://freemedforms.com/en/start</url>
  <updatecontact>eric.maeker@gmail.com</updatecontact>
</application>
EOF

# Remove packagehelpers part
rm -fvr $RPM_BUILD_ROOT/%{_datadir}/%{name}/package_helpers/

%files
%doc COPYING.txt README.txt

%files emr
%{_bindir}/%{name}
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*.so
%{_libdir}/%{name}/*pluginspec
%dir %{_datadir}/%{name}/
%{_datadir}/appdata/%{name}.appdata.xml
%{_datadir}/applications/%{name}.desktop
%{_datadir}/pixmaps/%{name}.svg
%{_mandir}/man1/%{name}.*
%dir %{_docdir}/%{projectname}-project/%{name}/

%files emr-data
%{_datadir}/%{name}/forms/
%{_datadir}/%{name}/profiles/

%files emr-docs-en
%{_docdir}/%{projectname}-project/%{name}/en/

%files emr-docs-fr
%{_docdir}/%{projectname}-project/%{name}/fr/

%files common-translations
%{_datadir}/%{name}/translations/

%files common-libs
%dir %{_libdir}/%{projectname}-common
%{_libdir}/%{projectname}-common/*so.*
%{_libdir}/%{projectname}-common/*so

%files common-resources
%dir %{_docdir}/%{projectname}-project/
%{_datadir}/%{projectname}/datapacks/
%{_datadir}/%{projectname}/pixmap/
%{_datadir}/%{projectname}/textfiles/
%{_datadir}/%{projectname}/sql/

%files -n freediams
%doc COPYING.txt README.txt
%{_bindir}/freediams
%{_datadir}/appdata/freediams.appdata.xml
%{_datadir}/applications/freediams.desktop
%{_datadir}/pixmaps/freediams.svg
%{_mandir}/man1/freediams.*
%dir %{_libdir}/freediams
%{_libdir}/freediams/*.so
%{_libdir}/freediams/*pluginspec
%dir %{_docdir}/%{projectname}-project/freediams/

%files -n freediams-docs-en
%{_docdir}/%{projectname}-project/freediams/en


%files -n freediams-docs-fr
%{_docdir}/%{projectname}-project/freediams/fr

%changelog
* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.4-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat May 02 2015 Kalev Lember <kalevlember@gmail.com> - 0.9.4-3
- Rebuilt for GCC 5 C++11 ABI change

* Thu Mar 26 2015 Richard Hughes <rhughes@redhat.com> - 0.9.4-2
- Add an AppData file for the software center

* Tue Sep 16 2014 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.9.4-1
- Update to latest upstream release
- Merge freediams to this spec too

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.0-0.3.beta1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.0-0.2.beta1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Aug 15 2013 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.9.0-0.1.beta1
- Based on Eric's spec
- Update to 0.9.0~beta1
- Update build system 0.9.0
- Adding some comments
- Correcting some package content
- Rpaths, but internal libraries so OK

* Sun May 19 2013 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.8.2.1-1
- Update to 0.8.2.1

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.5-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.5-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jun 28 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.7.5-6
- Some more reorganizing of files in packages:
- the sql, datapacks, pixmaps are common components for the entire suite

* Thu Jun 28 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.7.5-5
- Bump spec for ownership changes

* Thu Jun 28 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.7.5-4
- Added freediams
- Split another subpackage for common-resources
- Added projectname macro to use in project common files

* Thu Jun 28 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.7.5-3
- Try patch upstream suggested
- Add obsoletes to maintain upgrade path

* Wed Jun 27 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.7.5-2
- Split to subpackages to make it easier to install suite applications
- Split arch indep packages

* Wed Jun 27 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.7.5-1
- Update to 0.7.5

* Wed Jun 27 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.7.4-1
- Update to 0.7.4

* Wed Jun 27 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.5.9-0.6.alpha1
- Filter requires!

* Wed Jun 27 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.5.9-0.5.alpha1
- Remove stray requires on -devel package (removed)

* Wed Jun 27 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.5.9-0.4.alpha1
- Filter provides

* Wed Jun 27 2012 Ankur Sinha <ankursinha AT fedoraproject DOT org> 0.5.9-0.3.alpha1
- Remove devel package since so files are privately used plug-ins
- rhbz#742396

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.9-0.2.alpha1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Jun 15 2011 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.5.9-0.1alpha1
- Let rpath be
- Corrections as Eric suggested at https://bugzilla.redhat.com/show_bug.cgi?id=707002#c2

* Sat May 28 2011 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.5.9-0.1alpha1
- Used chrpath to remove rpath additions
- Initial rpm build
- Based on the spec used for OpenSUSE maintained by Sascha Manns.


